// select `Tools`->`Board:`->ESP32 -> ESP32 Dev Module
/* http://www.brettoliver.org.uk/
 * Brett v1 add Kenley Time Server details
 * Brett v3 adapt to ESP32WROOM
 * v4 remove reverse on start
 * v5 output pins changed to stepper modules to suit verobord layout
 * v6 adding LED outputs-removing adafruit Neopixel
 * v7 add start button - prevents clock auto restarting on power up
 * v8 add NTP fail LED
 * v9 add check NTP time every hour removes comments on 218 to 221 to check at midnight or 224 to 227 to check on the hour
 * v10 add summertime button removed hourly check off time as per v9 above Hour corrects on next minute change
 *  need to add summertime as per word clock 3D
 * v1 Tank Clock unchanged from Card Clock v10
 * v2 Tank Clock test add serial print H M S line 294 run every sec, mun and hour added to loop
 * v3 stripping old code
 * v4 old code stripped
 * v5 added stepper kibrary working hours and min
 * v6 adding auto home all working
 * v7 sdded auto home on the hour- to add end stop alert if end stop not found
 * v8 adding RTC endStopminPin = 25; // was 21 and endStophourPin = 26;// was 22 to make way for I2C for RTC  ####### abandoned use v9
 * v9 reverted to v8 code no RTC but kept endStopminPin = 25; // was 21 and endStophourPin = 26;// was 22
 * v10 add full chimes
 * v11 added test button to step 1 hour
 * v12 changed chime always switch to input_pullup
 * v13 slow minute hand speed- adjusted end stop value to match- adjusted hour chime timings to let the motors home before sounding the hour chime, 4 1/4 chime moved from 55 to 59 seconds 
       changes to midnite/midday as stepper was not working at these times LED added to man step button to show when to release it
       not working hour steps back to 2 at 12 and 0hrs
 * v14 fixing hour problem at 12 and 0 hr 
 * v15 if (h > 12)  h = h - 12 moved to start on hr calc 497   added stepper2.setCurrentPosition(0); to se new hom just for midday and midnite
   removed 291 to 300  269 if ((h == 12) && (m == 01) && (s == 00)) { set first run to 0
 * v18 made hour as min fails steps to 12 OK then steps back 20 seconds later
 * v19 490 if ((prevHour != tmtime.tm_hour) && (h != 12) )
 * v20 520  prevHour = 12  line 291 added else if ((h == 12) || (h == 0))    x stepper1.setCurrentPosition(0); 
   hour man step faulty- steps OK to 12- prehour old 23 prehournew 0 - at 01:00 steps back to 3oclock- prehour old 0 prehournew 1 hposition 800-
   on do every min printing mposition to compare with hposition on the hour
   23:00
  
*v22 Move line 305 to 329 to do every hour line 534  change if ((h == 1) || (h == 13)) 
* Line 273 check time 08:30:30 every day
01:00 worked
19:38:25.011 -> hour 02 minute 38 second 25
19:38:26.319 -> h=2
19:38:26.319 -> hposition 800
19:38:27.113 -> hposition 800


   OK Midday OK Midnight
* v23 adjusting acceleration use stepper2.setAcceleration(100.0);
* v24 turn Green LED WIFI OK off after strt pressed
* v25 add daily time check
* v26 to add end stop fail see 801 and void MinEndStopFail()
* v27 change chime to before hour
* v28 change minutes from 180deg sweep to 300 deg sweep
* v29add armirtise chime after 2min silence 11 Nov 11 am
* v30 change hour chimes to 58secs
* v31 fix non home when homwe light already on Add full qtr chime befroe O'clcock chime
* v32 fix timed chime control
 */

//#include <Adafruit_NeoPixel.h>
#include "WiFi.h"
#include <AccelStepper.h>
#include <MultiStepper.h>
// Define the stepper motor and the pins that is connected to
AccelStepper stepper1(1, 19, 18);  // (Typeof driver: with 2 pins, STEP, DIR)
AccelStepper stepper2(1, 17, 16);


MultiStepper steppersControl;  // Create instance of MultiStepper
#include <SoftwareSerial.h>
#include <JQ6500_Serial.h>
// Create the mp3 module object,chimevolume
//   Arduino Pin 32 is connected to TX of the JQ6500
//   Arduino Pin 33 is connected to one end of a  1k resistor,
//     the other end of the 1k resistor is connected to RX of the JQ6500
//   If your Arduino is 3v3 powered, you can omit the 1k series resistor
JQ6500_Serial mp3(32, 33);

//long gotoposition[1]; // An array to store the target positions for each stepper motor
long gotoposition[2];  // An array to store the target positions for each stepper motor
int h = 0;             // hours
int hposition = 0;
int m = 0;  // mins
int mposition = 0;

int s = 0;  //secs

int sleep1 = 14;
int sleep2 = 13;

long minStep = 45;    // was 27
long hourStep = 773;  // was 800

int manhourStep = 21;      // man adjust + 1hour each press of hour test button
int manhourStepvalue = 0;  // value of manhourStep pin

// each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
long minHome = 0;  // just over a full rotation

// each hour step is hourStep long and 12 of them rotate the stepper about 360deg so 13 (give > a full rotation) x hourStep x will give > a full rotation
long hourHome = 0;  //11154; // just over a full rotation

//Chimes

int chimeAlways = 27;  // Turns On Off chime timer
int chimevolUp = 36;
int chimevolDn = 39;
int chimevolume = 0;
int chimeFile = 0;
int chimetestup = 0;  // used to test chime when vol + is pressed and let go
int chimetestdn = 0;  // used to test chime when vol - is pressed and let go
int chimestart = 1;   // enables chimes when timer on
int chimeon = 0;
//int chimeReady            = 0; // enabled after home position is reached so hour full 1/4 and chime won't ring until home reached

// NTP settings
int TIMEZONE = 0;                 // timezone (GMT = 0, Japan = 9 1 = gmt summertime)

#define NTP_SERVER "uk.pool.ntp.org" //use your local time server

#define WIFI_SMARTCONFIG false

#if !WIFI_SMARTCONFIG
// if you do not use smartConfifg, please specify SSID and password here


#define WIFI_SSID "SSID" // your WiFi's SSID
#define WIFI_PASS "Password" // your WiFi's passwor



#endif

#define WIFI_Fail_LED_PIN 4
#define WIFI_Get_LED_PIN 12
#define WIFI_OK_LED_PIN 15
#define Start_Sw 34
#define Summertime_Sw 35
int summertime = 0;
int firstrun = 0;   //blocks start until start button is pressed
int firstrun1 = 0;  //stops hour motor continualy checking after initial run
int start = HIGH;
int endStopminPin = 25;   // was 21
int endStophourPin = 26;  // was 22
//int minVal;// digital read value of hall sensor
//int hourVal;// digital read value of hall sensor



#define MIN1 0
#define MIN10 1
#define HOUR 2



void setup() {
  digitalWrite(sleep1, HIGH);  // turn off steppers at start
  digitalWrite(sleep2, HIGH);  // turn off steppers at start
  Serial.begin(115200);
  Serial.println("start");
  pinMode(WIFI_Fail_LED_PIN, OUTPUT);
  pinMode(WIFI_Get_LED_PIN, OUTPUT);
  pinMode(WIFI_OK_LED_PIN, OUTPUT);
  pinMode(Start_Sw, INPUT);
  pinMode(Summertime_Sw, INPUT);
  pinMode(endStopminPin, INPUT);
  pinMode(endStophourPin, INPUT);
  pinMode(sleep1, OUTPUT);
  pinMode(sleep2, OUTPUT);
  pinMode(chimeAlways, INPUT_PULLUP);  //used to set chime timer/chime 24/7  (24/7 LOW Timer High)
  pinMode(chimevolUp, INPUT);
  pinMode(chimevolDn, INPUT);
  pinMode(manhourStep, INPUT_PULLUP);
  chimevolume = 30;  //was 15
  chimestart = 1;    // set timer ready for startup
  //JQ9500 sound module
  mp3.begin(9600);
  mp3.reset();
  mp3.setVolume(24);
  mp3.setLoopMode(MP3_LOOP_NONE);
  //stepper1.setMaxSpeed(300.0);  // Set maximum speed value for the stepper
  //stepper2.setMaxSpeed(1000.0);


  // Adding the 3 steppers to the steppersControl instance for multi stepper control
  steppersControl.addStepper(stepper1);
  steppersControl.addStepper(stepper2);



  digitalWrite(WIFI_Fail_LED_PIN, HIGH);  //Light NTP fail LED at start



  wifiSetup();

  getNTP();

  // If the turret/min indicator is already at or near the end stop/home position we move it on to a non home position
  if (digitalRead(endStopminPin) == 0) {
    endstopMin();
  }

  // If the tank body/hours is already at or near the end stop/home position we move it on to a non home position
  if (digitalRead(endStophourPin) == 0) {
    endstopHour();
  }


  delay(1000);

  //Mins turret and hours tank body are now homed ready to set the time

  endstopHourzero();  // home hour Stepper
  endstopMinZero();   // home minute Stepper




  stepper1.setMaxSpeed(300.0);  // Set maximum speed value for the stepper
  stepper2.setMaxSpeed(500.0);
  stepper2.setAcceleration(500.0);
  stepper1.setAcceleration(500.0);
}

void loop() {
  start = digitalRead(Start_Sw);
  if (start == LOW || firstrun == 1) {
    firstrun = 1;
    digitalWrite(WIFI_OK_LED_PIN, LOW);  //Turn off Green LED when start is pressed
    //Serial.println("Start");


    static int prevSec = -1;
    static int prevMin = -1;
    static int prevDay = -1;
    static int prevHour = -1;  // was -1 v22
    int hour;
    struct tm tmtime;

    getLocalTime(&tmtime);



    // rechecks time when start button is pressed to sync winter/summer time
    if (start == LOW) {
      Serial.println("getntp");
      getNTP();
    }

    //from stepper blocking##############
    s = tmtime.tm_sec;

    m = tmtime.tm_min;

    h = tmtime.tm_hour;

    // reset itself at 08:30:30 to get accurate time

    if (h == 8 && m == 26 && s == 30) {
      if (prevDay > 0 && tmtime.tm_mday != prevDay)  // day of the month - [ 1 to 31 ]
      {
        Serial.print("Previous Day ");
        Serial.println(prevDay);
        getNTP();
        prevDay = tmtime.tm_mday;
        Serial.print("Previous Day ");
        Serial.println(prevDay);
      }
    }

    // m = m + 1;
    if ((m == 0) && (s == 0)) {
      endstopMinZero();  // home minute Stepper
      mposition = 0;

      // this position is 0 min so move min had to 0 seconds ########################################################
      // m = 1;
      // Serial.print("m ");
      // Serial.print(m);
      //Serial.println(" ");
    } else {
      //Serial.print("m ");
      // Serial.print(m);
      // Serial.println(" ");
      mposition = m * minStep;
      //Serial.print("mposition ");
      // Serial.println(mposition);
    }






    // change 24h time to 12h time
    if (h == 0) {
      h = 12;

    }

    else if (h > 12) {
      h = h - 12;
    }










    //#########################


    //Do every second
    if (prevSec != tmtime.tm_sec) {
      //Serial.println("1sec");
      prevSec = tmtime.tm_sec;

      manhourStepvalue = digitalRead(manhourStep);
      if (manhourStepvalue == LOW)  //man step timezone if Manstep pressed for 1 sec
      {
        digitalWrite(WIFI_Get_LED_PIN, HIGH);  //lights get WIFI led when ready to release man step button
        getNTPTest();
        digitalWrite(WIFI_Get_LED_PIN, LOW);  //turns off get WIFI led when next hour has loaded
      }



      // Chimes ##################################################
      // Set chime timer or chime on 24/7
      // If Chime Timer switch is on (HIGH)
      //Once triggerred chime stays on until deactivated by time set below to deactivate
      // On initial power up time is checked just before every 1/4 to see if chime should be ON
      if (digitalRead(chimeAlways) == HIGH && tmtime.tm_hour >= 6 && tmtime.tm_hour <= 23 && (m == 14 || m == 29 || m == 44 || m == 59) && chimestart == 1)  //Note CET/CEST used to set chime timer/chime 24/7  (24/7 LOW & Timer High)
      {

        chimestart = 0;
        chimeon = 1;
        
   /*
   Serial.print ("chimeAlways "); 
    Serial.println ("TIMER");
    Serial.print ("Chimestart "); 
    Serial.println (chimestart);
     Serial.print ("Chimeon "); 
    Serial.println (chimeon);
    */
      }

      else if (digitalRead(chimeAlways) == LOW)

      {
        chimeon = 1;
        /*
    Serial.print ("chimeAlways "); 
   Serial.println ("24/7");
    Serial.print ("Chimestart "); 
    Serial.println (chimestart);
     Serial.print ("Chimeon "); 
    Serial.println (chimeon);
    */
      }


      // If Chime Timer switch is ON HIGh but time is out of range. Once de-activasted chime stays off untill time is in range angaim
      if (digitalRead(chimeAlways) == HIGH &&  tmtime.tm_hour < 6 && tmtime.tm_hour > 23 && m == 1 && chimestart == 0)  //Note CET/CEST used to set chime timer/chime 24/7  (24/7 LOW & Timer High)
      {

        chimestart = 1;
        chimeon = 0;
        /*
   Serial.print ("chimeAlways "); 
    Serial.println ("TIMER OFF ");
    Serial.print ("Chimestart "); 
    Serial.println (chimestart);
     Serial.print ("Chimeon "); 
    Serial.println (chimeon);
    */
      }

      // sound hour chimes and 1/4 hour chimes if chimeon set to 1 from above 2 if statements
      if (chimeon == 1) {
        quarterHourChime();
        hourChime();
      }




      //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      // Change chime volume.
      //Hold vol up or volume down for over a second to increment or decrement volume
      // Plays a test tone when button is released

      //Volume up

      if (digitalRead(chimevolUp) == LOW) {
        ++chimevolume;
        ++chimevolume;
        ++chimevolume;

        //max chime volume is 30 //30
        if (chimevolume > 30)  // 30
        {
          chimevolume = 30;  //30
        }
        // end max chime vol is 30

        mp3.setVolume(chimevolume);
        chimetestup = 1;
        Serial.print("Chime Volume ");
        Serial.println(chimevolume);
        //  Serial.print ("Chimetestup");
        //   Serial.println (chimetestup);
      }

      // Test tone played on release of volume up button
      if (chimetestup == 1 && digitalRead(chimevolUp) == HIGH) {

        mp3.playFileByIndexNumber(17);  // plays short test chime to test volume
        chimetestup = 0;
        //Serial.print ("Chimetestup");
        //   Serial.println (chimetestup);
      }


      //Volume down

      if (digitalRead(chimevolDn) == LOW) {
        --chimevolume;
        --chimevolume;
        --chimevolume;

        //min chime volume is 0
        if (chimevolume < 0) {
          chimevolume = 0;
        }
        //end min chime volume is 0


        mp3.setVolume(chimevolume);
        chimetestdn = 1;

        Serial.print("Chime Volume ");
        Serial.println(chimevolume);
        //   Serial.print ("Chimetestdn");
        //   Serial.println (chimetestdn);
      }
      // Test tone played on release of volume down button
      if (chimetestdn == 1 && digitalRead(chimevolDn) == HIGH) {
        mp3.playFileByIndexNumber(17);  // plays short chime to test volume
        chimetestdn = 0;
        //Serial.print ("Chimetestdn");
        //    Serial.println (chimetestdn);
      }
      // 2min silence end 11/11
      if (tmtime.tm_mon == 10 & tmtime.tm_mday == 11 & h == 11 & m == 2 & s == 1)  // chime @ 11th Nov 2 mins past 11 to show 2min silence has ended-- note month starts at 0 eg Nov is 10
      {

        mp3.playFileByIndexNumber(15);
      }


      //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    }




    //Do every minute
    if (prevMin != tmtime.tm_min) {
      //Serial.println("1min");
      prevMin = tmtime.tm_min;
      // Serial.print("S= ");
      //Serial.println(s);

      //stepper min enableOutputs
      digitalWrite(sleep1, LOW);
      // Store the target positions in the "gotopostion" array
      gotoposition[0] = mposition;  // 800 steps - full rotation with quater-step resolution
                                    //gotoposition[1] = 1800;


      steppersControl.moveTo(gotoposition);  // Calculates the required speed for all motors
      steppersControl.runSpeedToPosition();  // Blocks until all steppers are in position

      //stepper min disableOutputs
      digitalWrite(sleep1, HIGH);


      //Serial.print("m ");
      // Serial.print(m);
      //Serial.println(" ");
      //Serial.print("mposition ");
      // Serial.println(mposition);
      //Serial.print("h ");
      //Serial.print(h);
      //Serial.println(" ");
      //Serial.print("hposition ");
      // Serial.println(hposition);





      // delay(1000);
      //#######################################################################
    }


    //Do every hour

    if (prevHour != tmtime.tm_hour) {
      //Serial.print("1hour= ");
      //Serial.println(hour);

      //Serial.print("prehourold ");
      // Serial.println(prevHour);

      prevHour = tmtime.tm_hour;
      //Serial.print("prehournew ");
      //Serial.println(prevHour);

      if ((h == 1) || (h == 13))  // 12 midday or midnight oclock are endstop position
      {
        endstopHourzero();  // home hour Stepper
        //firstrun1 = 1;  // makes sure hour motor stops stepping once homed
        //stepper2.setCurrentPosition(0);
        hposition = 0;  // no extra steps required as midday/midnight are at hour endstop
        //stepper2.setCurrentPosition(800);  //reset stepper position
        // hposition = hourStep;
        Serial.println("h=1 ");
        // Serial.println(h);
        // Serial.print("firstrun1 12 oclock ");
        // Serial.println(firstrun1);

      }

      else if ((h == 2) || (h == 14)) {
        stepper2.setCurrentPosition(0);
        Serial.print("hposition before=");
        Serial.println(hposition);

        hposition = hourStep * 1;
        Serial.print("hposition after ");
        Serial.println(hposition);
      }




      else if (h == 3) {
        Serial.println("h=3 ");

        hposition = hourStep * 2;
        Serial.print("hposition ");
        Serial.println(hposition);
      }

      else if (h == 4) {
        Serial.println("h=4 ");

        hposition = hourStep * 3;
      }

      else if (h == 5) {
        Serial.println("h=5 ");

        hposition = hourStep * 4;
      }

      else if (h == 6) {
        Serial.print("hposition before=");
        Serial.println(hposition);
        Serial.println("h=6 ");

        hposition = hourStep * 5;
        Serial.print("hposition after ");
        Serial.println(hposition);
      }

      else if (h == 7) {
        Serial.println("h=7 ");

        hposition = hourStep * 6;
      }


      else if (h == 8) {
        Serial.println("h=8 ");

        hposition = hourStep * 7;
      }

      else if (h == 9) {
        Serial.println("h=9 ");

        hposition = hourStep * 8;
      }

      else if (h == 10) {
        Serial.println("h=10 ");

        hposition = hourStep * 9;
      }

      else if (h == 11) {
        Serial.println("h=11 ");

        hposition = hourStep * 10;
      }

      else if (h == 12) {
        Serial.println("h=12 ");

        hposition = hourStep * 11;
      }



      if ((h != 1) && (h != 13)) {

        //stepper hour enableOutputs
        digitalWrite(sleep2, LOW);
        // Store the target positions in the "gotopostion" array

        gotoposition[1] = hposition;
        // gotoposition[1] = hposition + m;



        steppersControl.moveTo(gotoposition);  // Calculates the required speed for all motors/////////////////////////////
        steppersControl.runSpeedToPosition();  // Blocks until all steppers are in position

        //stepper hour disableOutputs
        digitalWrite(sleep2, HIGH);

        //Serial.print("h= ");
        //Serial.print(h);
        //Serial.println(" ");
        Serial.print("hposition  ");
        Serial.println(hposition);
        //Serial.print("firstrun1 hour ");
        // Serial.print(firstrun1);
      }
    }
  }
}  // needs start button pressed to run
//////////////////////////////
// WiFi and NTP section
//////////////////////////////

void getNTP(void) {
  for (int i = 0; WiFi.status() != WL_CONNECTED; i++) {
    if (i > 30) {
      ESP.restart();
    }
    Serial.println("Waiting for WiFi connection..");
    delay(1000);
  }
  // check for sumertime
  summertime = digitalRead(Summertime_Sw);





  if (summertime == HIGH)  // Summertime sw is off
  {
    TIMEZONE = 0;  //Set for GMT
  }


  else if (summertime == LOW)  // Summertime sw is on
  {
    TIMEZONE = 1;  //Set for GMT + 1 ## can be used for testing times other times
  }

  configTime(TIMEZONE * 3600L, 0, NTP_SERVER);
  printLocalTime();
}



void getNTPTest() {  //used to man set hour for clock testing

  TIMEZONE = TIMEZONE + 1;

  Serial.print("Timezone set to ");
  Serial.println(TIMEZONE);
  Serial.println("getntpTest");
  configTime(TIMEZONE * 3600L, 0, NTP_SERVER);
  printLocalTime();
  delay(300);
}

void printLocalTime() {
  struct tm timeinfo;
  if (!getLocalTime(&timeinfo)) {
    Serial.println("Failed to obtain time");
    digitalWrite(WIFI_Fail_LED_PIN, HIGH);
    digitalWrite(WIFI_OK_LED_PIN, LOW);

    return;
  }
  //Serial.println(&timeinfo, "%A, %Y-%m-%d %H:%M:%S");

  Serial.print("hour ");
  Serial.print(&timeinfo, "%H");
  Serial.print(" minute ");
  Serial.print(&timeinfo, "%M");
  Serial.print(" second ");
  Serial.println(&timeinfo, "%S");
  delay(1000);
}


void wifiSetup() {
  WiFi.mode(WIFI_STA);
#if WIFI_SMARTCONFIG
  WiFi.begin();
#else
  WiFi.begin(WIFI_SSID, WIFI_PASS);
#endif

  for (int i = 0;; i++) {
    Serial.println("Connecting to WiFi...");
    //digitalWrite(WIFI_Get_LED_PIN, HIGH);
    digitalWrite(WIFI_OK_LED_PIN, LOW);
    delay(500);
    digitalWrite(WIFI_Get_LED_PIN, HIGH);
    delay(500);
    digitalWrite(WIFI_Get_LED_PIN, LOW);

    if (WiFi.status() == WL_CONNECTED) {
      digitalWrite(WIFI_Fail_LED_PIN, LOW);
      digitalWrite(WIFI_Get_LED_PIN, LOW);
      digitalWrite(WIFI_OK_LED_PIN, HIGH);
      break;
    }
#if WIFI_SMARTCONFIG
    if (i > 30)
      break;
#endif
  }

#if WIFI_SMARTCONFIG
  if (WiFi.status() != WL_CONNECTED) {
    WiFi.mode(WIFI_AP_STA);
    WiFi.beginSmartConfig();

    //Wait for SmartConfig packet from mobile
    Serial.println("Waiting for SmartConfig.");
    while (!WiFi.smartConfigDone()) {
      Serial.print(".");
      //pixels.setPixelColor(0, pixels.Color(0, 255, 0)); // red
      // pixels.show();
      delay(1000);
    }

    Serial.println("");
    Serial.println("SmartConfig received.");

    //Wait for WiFi to connect to AP
    Serial.println("Waiting for WiFi");
    while (WiFi.status() != WL_CONNECTED) {
      delay(1000);
      Serial.print(",");
    }
  }
  Serial.println("WiFi Connected.");
#endif

  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());
  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());
}
//#########################################################
// steps min away from home
void endstopMin() {             // homes min stepper
  stepper1.setMaxSpeed(250.0);  // was 1000 Set maximum speed value for the stepper
  stepper1.setAcceleration(500.0);
  stepper1.setSpeed(150.0);
  Serial.println("Minute homing........");
  //stepper hour enableOutputs
  digitalWrite(sleep1, LOW);

  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 0 && minHome < 1509640)  //was 399640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;

    //minHome = minHome-1; // steps the motor back towards home
    //Serial.println(minHome);
    // Serial.println(minVal);
  }

  //stepper hour disableOutputs
  digitalWrite(sleep1, HIGH);
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now away from home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}


//#########################################################
void endstopMinZero() {         // homes min stepper
  stepper1.setMaxSpeed(250.0);  // was 300Set maximum speed value for the stepper
  stepper1.setAcceleration(500.0);
  stepper1.setSpeed(150.0);  //was300
  Serial.println("Minute homing........");
  //stepper hour enableOutputs
  digitalWrite(sleep1, LOW);

  //minVal = digitalRead(endStopminPin);
  //Serial.print("minVal ");
  //Serial.println(minVal);
  //delay(2000);
  stepper1.setCurrentPosition(0);  //reset stepper position
  //while (minVal == 1 && minHome <3164)
  while (digitalRead(endStopminPin) == 1 && minHome < 1909640)  //1509640 number must be > than a full turn so home position sensor is alway reached
  {
    stepper1.moveTo(minHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper1.run();
    minHome++;

    //minHome = minHome-1; // steps the motor back towards home
  }

  Serial.print("Min zero stepper now home- minHome=");
  Serial.println(minHome);
  //stepper hour disableOutputs
  digitalWrite(sleep1, HIGH);
  if (minHome == 1909640)  // 1509640 stop clock and flash LED if end stop not found
  {
    MinEndStopFail();
  }
  Serial.println(minHome);
  minHome = 0;  // minHome must be reset or minHome count will eventually be > 399640 b4 home is reached
  Serial.println("Minutes stepper now home");
  stepper1.setCurrentPosition(0);  //reset stepper position to new home
}

//########################################################

//########################################################
//if endstop aleady active steps until endstop is off
void endstopHour() {
  stepper2.setMaxSpeed(500.0);  // Set maximum speed value for the stepper
  stepper2.setAcceleration(500.0);
  stepper2.setSpeed(300.0);
  Serial.println("Hours moving away from home........");
  //stepper hour enableOutputs
  digitalWrite(sleep2, LOW);


  stepper2.setCurrentPosition(0);                                 //reset stepper position
  while (digitalRead(endStophourPin) == 0 && hourHome < 2774944)  // number must be > than a full turn so home position sensor is alway reached
  {
    stepper2.moveTo(hourHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper2.run();
    hourHome++;  // steps the motor back towards home
    //Serial.println(hourHome);
  }

  //stepper hour disableOutputs
  digitalWrite(sleep2, HIGH);

  //chimeReady = 1;

  Serial.println("Hour stepper now away from home");
  Serial.println(hourHome);
  hourHome = 0;                    // hourHome must be reset or hourHome count will eventually be > 1274944 b4 home is reached
  stepper2.setCurrentPosition(0);  //reset stepper position to new home
}

//########################################################
void endstopHourzero() {
  stepper2.setMaxSpeed(500.0);  // Set maximum speed value for the stepper
  stepper2.setAcceleration(500.0);
  stepper2.setSpeed(300.0);
  Serial.println("Hours homing........");
  //stepper hour enableOutputs
  digitalWrite(sleep2, LOW);

  stepper2.setCurrentPosition(0);                                 //reset stepper position
  while (digitalRead(endStophourPin) == 1 && hourHome < 2774944)  // 2774944 number must be > than a full turn so home position sensor is alway reached
  {
    stepper2.moveTo(hourHome);  // each min step is minStep long and the mins are shown over 180deg so 61min x minstep x 2(to make 360deg) will give a full rotation
    stepper2.run();
    hourHome++;  // steps the motor back towards home
    //Serial.println(hourHome);
  }


  //stepper hour disableOutputs
  digitalWrite(sleep2, HIGH);

  if (hourHome == 2774944)  // was 2774944 stop clock and flash LED if end stop not found
  {
    HourEndStopFail();
  }

  //chimeReady = 1;

  Serial.print("Hour zero stepper now home- hourHome=");
  Serial.println(hourHome);
  hourHome = 0;
  //Serial.print("hourHome reset to zero=");
  //Serial.println(hourHome);        // hourHome must be reset or hourHome count will eventually be > 1274944 b4 home is reached
  stepper2.setCurrentPosition(0);  //reset stepper position to new home
}






//================================================================================================================
//
// Function name : quarterhourchime
// called from   : <tasksEverySecond>
//
// Purpose       : chime 1/4 1/2 & 3/4 hours
// Parameters    : none
// Return value  : none
//
//================================================================================================================
void quarterHourChime() {


  if ((m == 15 || m == 30 || m == 45) && s == 2)  //ok on 5
  {
    //load index variable with file index number
    // play selected 1/4 chime through the JQ6500(a IC3)
    switch (m) {
      case 15: mp3.playFileByIndexNumber(13); break;
      case 30: mp3.playFileByIndexNumber(14); break;
      case 45: mp3.playFileByIndexNumber(15); break;
    }
  }
if ((m == 59) && s == 53)  //ok on 5
  {
    //load index variable with file index number
    // play selected 1/4 chime through the JQ6500(a IC3)
     mp3.playFileByIndexNumber(16);
  }
}

/*
 if (m == 0 && s == 7 )//was 55
{
 
      mp3.playFileByIndexNumber(16);//at oclock the chime starts after the motor has moved
    
    }
   


}  //end of quarterHourChime

  
*/

//================================================================================================================
//
// Function name : hourChime
// called from   : <tasksEverySecond>
//
// Purpose       : chime hours
// Parameters    : none
// Return value  : none
//
//================================================================================================================
/*
void hourChime() {
  //if its getting near to start of the chime

  //if its time for the chime to start after steeper motor has homed

  if (m == 0 && s == 8)  //was 0
  {
    //calculate filenumber variable to ensure  results 1 - 12
    if (h == 0)  // if midnight  make hours = 24
    {
      chimeFile = 24;
    }

    else {
      chimeFile = h;  //was -1;// convert for GMT
    }

    if (chimeFile > 12) chimeFile = chimeFile - 12;

    // play selected hour chime through the JQ6500(a IC3)
    switch (chimeFile) {
      case 1: mp3.playFileByIndexNumber(1); break;
      case 2: mp3.playFileByIndexNumber(2); break;
      case 3: mp3.playFileByIndexNumber(3); break;
      case 4: mp3.playFileByIndexNumber(4); break;
      case 5: mp3.playFileByIndexNumber(5); break;
      case 6: mp3.playFileByIndexNumber(6); break;
      case 7: mp3.playFileByIndexNumber(7); break;
      case 8: mp3.playFileByIndexNumber(8); break;
      case 9: mp3.playFileByIndexNumber(9); break;
      case 10: mp3.playFileByIndexNumber(10); break;
      case 11: mp3.playFileByIndexNumber(11); break;
      case 12: mp3.playFileByIndexNumber(12); break;
    }
    //chimeReady = 0;
  }
}  //end of <hourChimes> return to <loop>


*/

//#####################################################################################
void hourChime() {

  //Hour chimes must comple before steeper motors start to home


  //calculate filenumber variable to ensure  results 1 - 12
  if (h == 0)  // if midnight  make hours = 24
  {
    chimeFile = 24;
  }

  else {
    chimeFile = h;
  }

  if (chimeFile > 12) {
    chimeFile = chimeFile - 12;
  }


  if (chimeFile == 12 & m == 59 & s == 58)  // chime 1 olcock
  {

    mp3.playFileByIndexNumber(1);
  }

  else if (chimeFile == 1 & m == 59 & s == 58)  // chime 2 olcock
  {

    mp3.playFileByIndexNumber(2);
  }

  else if (chimeFile == 2 & m == 59 & s == 58)  // chime 3 olcock
  {

    mp3.playFileByIndexNumber(3);
  }

  else if (chimeFile == 3 & m == 59 & s == 58)  // chime 4 olcock
  {

    mp3.playFileByIndexNumber(4);
  }


  else if (chimeFile == 4 & m == 59 & s == 58)  // chime 5 olcock
  {

    mp3.playFileByIndexNumber(5);
  }


  else if (chimeFile == 5 & m == 59 & s == 58)  // chime 6 olcock
  {

    mp3.playFileByIndexNumber(6);
  }


  else if (chimeFile == 6 & m == 59 & s == 58)  // chime 7 olcock
  {

    mp3.playFileByIndexNumber(7);
  }

  else if (chimeFile == 7 & m == 59 & s == 58)  // chime 8 olcock
  {

    mp3.playFileByIndexNumber(8);
  }

  else if (chimeFile == 8 & m == 59 & s == 58)  // chime 9 olcock
  {

    mp3.playFileByIndexNumber(9);
  }


  else if (chimeFile == 9 & m == 59 & s == 58)  // chime 10 olcock
  {

    mp3.playFileByIndexNumber(10);
  }


  else if (chimeFile == 10 & m == 59 & s == 58)  // chime 11 olcock
  {

    mp3.playFileByIndexNumber(11);
  }

  else if (chimeFile == 11 & m == 59 & s == 58)  // chime 12 olcock
  {

    mp3.playFileByIndexNumber(12);
  }
}




// if minute end stop not found then clock stops and LED WIFI fail flshes
void MinEndStopFail() {
  digitalWrite(WIFI_Fail_LED_PIN, HIGH);
  delay(500);
  digitalWrite(WIFI_Fail_LED_PIN, LOW);
  delay(500);
  MinEndStopFail();
}


// if minute end stop not found then clock stops and LED WIFI GET flashes
void HourEndStopFail() {
  digitalWrite(WIFI_Get_LED_PIN, HIGH);
  delay(500);
  digitalWrite(WIFI_Get_LED_PIN, LOW);
  delay(500);
  HourEndStopFail();
}
